// -
//   ========================LICENSE_START=================================
//   O-RAN-SC
//   %%
//   Copyright (C) 2022: Nordix Foundation
//   %%
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//        http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//   ========================LICENSE_END===================================
//

package org.oransc.nonrtric.plt.capifcore.controller;

import org.oransc.capif.model.APIProviderEnrolmentDetails;
import org.oransc.capif.providermanagement.server.RegistrationsApi;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.net.URI;

@RestController
@RequestMapping("/api-provider-management/v1")
public class ProviderManager implements RegistrationsApi {

    @Override
    public ResponseEntity<APIProviderEnrolmentDetails> registrationsPost(APIProviderEnrolmentDetails apIProviderEnrolmentDetails) {
        apIProviderEnrolmentDetails.apiProvDomId(getDomainId(apIProviderEnrolmentDetails.getApiProvDomInfo()));
        URI uri = ServletUriComponentsBuilder
                .fromCurrentRequest()
                .path("/{id}")
                .buildAndExpand(apIProviderEnrolmentDetails.getApiProvDomId())
                .toUri();

        return ResponseEntity.created(uri).body(apIProviderEnrolmentDetails);

    }

    private String getDomainId(String domainInfo) {
     return "domain_id_" + domainInfo.replaceAll("\\s+", "_");
    }
}
