# Intro #

The rapp manger can be executed in python on the local machine see CMD1. A kube cluster need to be running and accessable by kubectrl
Or the rapp manager can be installed in the kube cluster - service and deployment, see CMD2 and CMD3.

In both cases, rest is used


# CMD1 Run in python #

`python3 app/rappman.py $PWD`

# CMD2 Build rapp manger container #

`docker build --build-arg NEXUS_PROXY_REPO=nexus3.onap.org:10001/ -t rappman .`

# CMD3 Apply rapp manger in kube #

`kubectl apply -f svc-app.yaml`

# CMD4 Delete rapp manger in kube #

`kubectl delete -f svc-app.yaml`

# Interface #

The host and port in the below url examples is for local python execution.
For running towards a local kube cluster, a Function test config should running or at least the kubeproxy as configured by a function test script. All curl cmds need to specify the proxy `--proxy http://localhost:<proxy-port` and `localhost:2222` shall be replaced with `rapp-man.nonrtric:9970`.

| cmd | description |
|-|-|
| `curl http://localhost:2222/charts` | json list of charts |
| `curl -X PUT   http://localhost:2222/charts/<chart-name> -F "chart=@<filename1>.tgz"  -F "values=@<filename1>.yaml"` | Upload char and overridde, at least one file need to be given. Multiple uploads are possible|
| `curl http://localhost:2222/charts/<chart-name>/status` | json structure of status, filenames etc |
| `curl -X POST 'http://localhost:2222/charts/<chart-name>?action=install&namespace=<namespace>' `| Install a chart in a namespace. If the chart is already installed, a helm upgrade is attempted |
| `curl -X POST 'http://localhost:2222/charts/<chart-name>?action=uninstall'` | Uninstall an previously installed chart |
| `curl -X DELETE 'http://localhost:2222/charts/<chart-name>'` | Deletes a chart. The chart cannot currently be installed |







